# These are the methods considered "base".
# A method is deemed base if it is obvious,
# simple, unobtrusive and widely useful.
#
# This list is still being refined.
#
# NOTE
#
# The #cmp methods are simply aliases for #<=>, they
# are here b/c String.succ is not compataible
# with it's own #<=> method. The #cmp method proves
# an effective way of dealing with when needs be.
#
# You can add methods to be automatiaclly loaded with
# these by appending their path to the nano/extra
# configuration file. (Remember though, other's will
# not have your same choices!)

# Internal Use
require 'nano/kernel/require_facet' # (to be deprecated)

# Elementary
require 'nano/comparable/cmp'
require 'nano/string/cmp'
require 'nano/nilclass/to_f'
require 'nano/nilclass/to_h'
require 'nano/binding/eval'
require 'nano/binding/self'
require 'nano/binding/caller'
require 'nano/module/basename'
require 'nano/proc/to_method'
require 'nano/kernel/constant'
require 'nano/kernel/called'    # better name?
require 'nano/symbol/to_proc'

# Elementary (Know Thyself)
require 'nano/hash/to_h'
require 'nano/range/to_r'
require 'nano/regexp/to_re'
require 'nano/time/to_time'

# "Minis" (Shorthands)
require 'nano/module/is'
require 'nano/kernel/fn'
require 'nano/kernel/here'
require 'nano/kernel/own'       # better name?

# Convenience
require 'nano/array/to_h'
require 'nano/enumerable/to_h'
require 'nano/enumerable/collect_with_index'
require 'nano/enumerable/each_slice'
require 'nano/file/self/read_list'
require 'nano/float/round_to'
require 'nano/float/round_at'
require 'nano/hash/slice'
require 'nano/matchdata/match'
require 'nano/matchdata/matchtree'
require 'nano/string/blank'
require 'nano/string/to_re'

# New Features
require 'nano/symbol/not'
require 'nano/kernel/as'

# extras
require 'rbconfig'
confdir = Config::CONFIG['sysconfdir']
extra_facets = File.join( confdir, 'facets', 'extra' )
if File.file?( extra_facets )
  extra_facets = File.read_list( extra_facets )
  extra_facets.each { |f| require f  }
end
